﻿import { world } from "@minecraft/server";


const shapes = [
                "~-1~-1~-1 ~1~1~1",  
                "~~~ ~~1~1",  
                "~-1~-1~-1 ~1~~2", 
                "~-1~~-1 ~1~1~1", 
                "~-1~-2~-1 ~1~~1"  
            ];


world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("zzk:frozen_tick", {
        onTick(event) {
            const { block } = event;
            let iceState = block.permutation.getState("zzk:ice");

            if (iceState > 1) {
                const randomCoords = shapes[Math.floor(Math.random() * shapes.length)];
                world.getDimension(block.dimension.id).runCommand(
                    `execute positioned ${block.location.x} ${block.location.y} ${block.location.z} run fill ${randomCoords} zzk:frozen ["zzk:ice"=${iceState-1}] replace air`
                );
                block.setPermutation(block.permutation.withState("zzk:ice", iceState - 1));
            } else {
                block.setPermutation(block.permutation.withState("zzk:ice", iceState - 1));
                world.getDimension(block.dimension.id).runCommand(
                    `setblock ${block.location.x} ${block.location.y} ${block.location.z} ${iceState == 0 ? "air" : "zzk:frozen_s"}`
                );
            
}
     
        }
    });
});



world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("zzk:fade", {
        onTick(event) {
            if (!event.block) return;
            event.block.dimension.runCommand(`setblock ${event.block.location.x} ${event.block.location.y} ${event.block.location.z} air`);
        }
    });
});


world.afterEvents.playerPlaceBlock.subscribe((event) => {
    const { player, block } = event;
    if (!player || !block) return;

    if (block.typeId === "zzk:fadingsnow") {
        if (player.matches({ families: ['zf'] })) {
            player.runCommand(`give @s zzk:fadingsnow`);
        } else {
            player.runCommand(`clear @s zzk:fadingsnow`);
        }
    }
});
